/*******************************************************************************
 * Copyright 2019, 2020 grondag
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License.  You may obtain a copy
 * of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations under
 * the License.
 ******************************************************************************/
package grondag.fluidity.impl.device;

import grondag.fluidity.api.device.EntityComponentContext;
import net.minecraft.class_1297;
import net.minecraft.class_1937;

@SuppressWarnings("rawtypes")
public final class EntityComponentContextImpl extends AbstractComponentContextImpl implements EntityComponentContext {
	private class_1297 entity;

	@SuppressWarnings("unchecked")
	@Override
	public <E extends class_1297> E entity() {
		return (E) entity;
	}

	@Override
	protected class_1937 getWorldLazily() {
		return entity.field_6002;
	}

	@SuppressWarnings("unchecked")
	private EntityComponentContextImpl prepare(DeviceComponentTypeImpl componentType, class_1297 entity) {
		this.componentType = componentType;
		this.entity = entity;
		mapping = componentType.getMapping(entity);
		return this;
	}

	private static final ThreadLocal<EntityComponentContextImpl> POOL = ThreadLocal.withInitial(EntityComponentContextImpl::new);

	static EntityComponentContextImpl get(DeviceComponentTypeImpl componentType, class_1297 entity) {
		return POOL.get().prepare(componentType, entity);
	}
}
